=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 libcapstone-dev,
 debhelper (>= 9),
 libjansson-dev,
 libwxgtk3.0-dev,
 xauth,
 xvfb,
 wx3.0-headers,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcapstone3,
 libjansson4,
 libwxgtk3.0-0v5,
 zlib1g
Description: Reverse Engineers' Hex Editor
