=== wxLua/modules/wxbind/CMakeLists.txt ===
project( wxLua_Modules_wxBind )

wxLua_Modules_wxBind_TARGETS()
