=== debian/changelog ===
rehex (0.3.91-0~debian9) stretch; urgency=low

  * Fix loading of plugins bundled as part of an AppImage.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 May 2021 14:00:49 +0100

rehex (0.3.90-0~debian9) stretch; urgency=low

  * Show disassembly of machine code in the main document view (#94).

  * Add font size settings to "View" menu (#97).

  * Add float/double types to "Set data type" menu (#104).

  * Fix selection by holding shift and clicking (#109).

  * Initial support for Lua plugins.

  * Process sections from PE EXE/DLL headers (#86).

  * [Mark Jansen] Save size of main window and tool panels (#88).

  * Don't resize tool panels unnecessarily.

  * Fix invalid cursor state when moving between regions.

  * Fix crash when deleting data (#113, #123).

  * Fix opening files with 8-bit filenames, and other encoding issues (#117).

  * Virtual segment mapping and display (#7).

  * Display inline comments by default (didn't always work).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 02 May 2021 20:52:13 +0100

rehex (0.3.1-0~debian9) stretch; urgency=low

  * Correctly display signed 16-bit values in "Decode values" panel.

  * Fix status bar offset going out of sync.

  * Move cursor when a row in the "Comments" panel is double clicked.

  * Focus document after updating position/selection via "Comments" panel.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 13 Nov 2020 22:22:21 +0000

rehex (0.3.0-0~debian9) stretch; urgency=low

  * [Mark Jansen] Use byte grouping setting from main window in diff window.

  * [Mark Jansen] Use Capstone disassembler rather than LLVM.

  * [Mark Jansen] Support disassembling 16-bit x86 machine code.

  * [Mark Jansen] Don't update tools which aren't visible.

  * [Vincent Bermel] Unhardcode linux launcher icon file type.

  * Fix an uncommon use-after-free crash when closing tabs in diff window.

  * Support for disassembling 6800/68000 and MOS6502 instruction sets
    (requires recent Capstone version).

  * [Mark Jansen] Close document when tab is clicked with middle mouse button.

  * [Mark Jansen] Don't create .rehex-meta files when there is nothing to save.

  * Implement Strings tool to find and list ASCII strings in the file.

  * Add option to calculate automatic bytes per line in whole byte groups.

  * Add "Fill range" tool for overwriting ranges of bytes with a pattern.

  * Preserve column alignment after comments.

  * [Mark Jansen] Mark a document dirty if highlighting is changed.

  * Add data type annotations.

  * Show ranges marked as integers in their decoded form in the hex view.

  * Performance improvements for documents with large numbers of comments.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 10 Nov 2020 13:11:30 +0000

rehex (0.2.0-0~debian9) stretch; urgency=low

  * Allow copying comments from a document and pasting them elsewhere in the
    same document or into another one.

  * Fixed bounds check when clicking on nested comments in a document.

  * Added context menu when right clicking on a comment in a document.

  * Optionally highlight byte sequences which match the current selection.
    ("Highlight data matching selection" or "PatternMatchHighlight").

  * Allow copying cursor offset from document context menu.

  * Correctly display offsets over 4GiB in the status bar.

  * Display offsets as XXXX:XXXX rather than XXXXXXXX:XXXXXXXX when the file
    size is under 4GiB.

  * Add per-document option for dec/hex offset display.

  * When first byte after a comment is deleted, show that the comment was
    deleted rather than leaving phantom comment on screen until regions are
    repopulated.

  * Add side-by-side comparison of chunks of data from files. Select data and
    choose "Compare..." from context menu to open diff window.

  * Clean up search threads when a tab is closed while a search is running.

  * Display bytes which have been modified since the file was saved in red.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 02 Jun 2020 18:09:06 +0100

rehex (0.1.0-0~debian9) UNRELEASED; urgency=low

  * Initial release

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Mar 2020 20:08:30 +0000
