=== debian/control ===
--- 
+++ 
@@ -5,7 +5,10 @@
  libcapstone-dev,
  debhelper (>= 9),
  libjansson-dev,
+ liblua5.3-dev,
  libwxgtk3.0-dev,
+ lua5.3,
+ pkg-config,
  xauth,
  xvfb,
  wx3.0-headers,
@@ -21,6 +24,7 @@
  ${misc:Depends},
  libcapstone3,
  libjansson4,
+ liblua5.3-0,
  libwxgtk3.0-0v5,
  zlib1g
 Description: Reverse Engineers' Hex Editor
