=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 export prefix := /usr
+export LUA := lua5.3
 
 # Snapshot builds are performed using source packages generated by git-buildpackage, which lack
 # the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
@@ -15,8 +16,16 @@
 	export GIT_COMMIT_SHA
 endif
 
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+	MAKE_J_FLAG = -j$(NUMJOBS)
+endif
+
+LLVM_CONFIG := llvm-config-7
+export LLVM_CONFIG
+
 %:
 	dh $@
 
 override_dh_auto_test:
-	xvfb-run -a -e /dev/stdout make check
+	xvfb-run -a -e /dev/stdout make $(MAKE_J_FLAG) check
